/*
 * boolean.c - 
 */

/*
 * $Id: boolean.c,v 1.2 1998/10/29 05:11:49 shige Exp $
 */

/*************************************/
/*                                   */
/*  File Name : boolean.c            */
/*  Update    : Yass.  Sep. 20 '90   */
/*              Yass.  Jul.  7 '90   */
/*                                   */
/*    Boolean operations             */
/*                                   */
/*************************************/

static char *RCSid="$Id: boolean.c,v 1.2 1998/10/29 05:11:49 shige Exp $";

#include "scheme.h"


/***********************************/
/*                                 */
/*  Essential standard procedures  */
/*                                 */
/***********************************/

/*  Written by Yass. Sep. 20 '90  */
Snot()
{
#ifdef USE_FALSE
# ifdef IEEE_SPEC
#  ifdef TOUCH_ARG
    if (touch_obj(getarg(1)) == LTAG_FALSE)
#  else
    if (getarg(1) == LTAG_FALSE)
#  endif
# else
#  ifdef TOUCH_ARG
    if (touch_obj(getarg(1)) == LTAG_FALSE || touch_obj(getarg(1)) == LTAG_NIL)
#  else
    if (getarg(1) == LTAG_FALSE || getarg(1) == LTAG_NIL)
#  endif
# endif
#else
# ifdef TOUCH_ARG
    if (touch_obj(getarg(1)) == LTAG_FALSE)
# else
    if (getarg(1) == LTAG_FALSE)
# endif
#endif
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}


/*  Written by Yass. Sep. 20 '90  */
Sbooleanp()
{ 
    SOBJ obj;

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    if (obj.obj == LTAG_FALSE || obj.obj == LTAG_T)
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}


