/*      @(#)resource.h 2.10 89/02/21 SMI; from UCB 4.1 83/02/10 */

/*
 * $Id: resource.h,v 1.2 1998/10/29 05:12:01 shige Exp $
 *
 * Missing parts for wait3() taken from SunOS 4.1
 */

#ifndef _resource_h
#define _resource_h

/*
 * Get rest of definitions from system include files
 */
#include <sys/resource.h>

/*
 * Resource utilization information.
 */

#define RUSAGE_SELF     0
#define RUSAGE_CHILDREN -1

struct  rusage {
        struct timeval ru_utime;        /* user time used */
        struct timeval ru_stime;        /* system time used */
        long    ru_maxrss;
#define ru_first        ru_ixrss
        long    ru_ixrss;               /* XXX: 0 */
        long    ru_idrss;               /* XXX: sum of rm_asrss */
        long    ru_isrss;               /* XXX: 0 */
        long    ru_minflt;              /* any page faults not requiring I/O */
        long    ru_majflt;              /* any page faults requiring I/O */
        long    ru_nswap;               /* swaps */
        long    ru_inblock;             /* block input operations */
        long    ru_oublock;             /* block output operations */
        long    ru_msgsnd;              /* messages sent */
        long    ru_msgrcv;              /* messages received */
        long    ru_nsignals;            /* signals received */
        long    ru_nvcsw;               /* voluntary context switches */
        long    ru_nivcsw;              /* involuntary " */
#define ru_last         ru_nivcsw
};

#endif /* _resource_h */
